<?php

/**
 * Cloudrexx
 *
 * @link      http://www.cloudrexx.com
 * @copyright Cloudrexx AG 2007-2015
 *
 * According to our dual licensing model, this program can be used either
 * under the terms of the GNU Affero General Public License, version 3,
 * or under a proprietary license.
 *
 * The texts of the GNU Affero General Public License with an additional
 * permission and of our proprietary license can be found at and
 * in the LICENSE file you have received along with this program.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * "Cloudrexx" is a registered trademark of Cloudrexx AG.
 * The licensing of the program under the AGPLv3 does not imply a
 * trademark license. Therefore any rights, title and interest in
 * our trademarks remain entirely with us.
 */

/**
 * Update the component table and fill it with the new values
 * @return bool true on success false otherwise
 */
function _updateComponent() {
    // get all Components
    $arrComponents = getComponents();
    try {
        // Drop existing values
        Cx\Lib\UpdateUtil::sql('TRUNCATE TABLE `' . DBPREFIX . 'component`');

        foreach ($arrComponents as $component) {
            Cx\Lib\UpdateUtil::sql("INSERT INTO `".DBPREFIX."component` (`id`,
                                        `name`, `type`)
                                    VALUES (" . $component['id']. ", '" . $component['name'] . "', '" . $component['type'] . "')");
        }
    } catch (\Cx\Lib\UpdateException $e) {
        return \Cx\Lib\UpdateUtil::DefaultActionHandler($e);
    }

    return true;
}

/**
 * Returns an array with each component.
 *
 * IMPORTANT the component list is generated by the pkg-manager
 * array(
 *      $key    =>  array(
 *                      id => component id,
 *                      name => component name,
 *                      type => component type,
 *                  )
 * @return array All components
 */
function getComponents()
{
    $arrComponents = array(
		array(
			'id'					=> 2,
			'name'					=> 'Stats',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 3,
			'name'					=> 'Gallery',
			'type'					=> 'module',
		),
		array(
			'id'					=> 4,
			'name'					=> 'Newsletter',
			'type'					=> 'module',
		),
		array(
			'id'					=> 5,
			'name'					=> 'Search',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 6,
			'name'					=> 'Contact',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 7,
			'name'					=> 'Block',
			'type'					=> 'module',
		),
		array(
			'id'					=> 8,
			'name'					=> 'News',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 9,
			'name'					=> 'Media1',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 10,
			'name'					=> 'GuestBook',
			'type'					=> 'module',
		),
		array(
			'id'					=> 11,
			'name'					=> 'Sitemap',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 12,
			'name'					=> 'Directory',
			'type'					=> 'module',
		),
		array(
			'id'					=> 13,
			'name'					=> 'Ids',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 14,
			'name'					=> 'Error',
			'type'					=> 'core',
		),
		array(
			'id'					=> 15,
			'name'					=> 'Home',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 16,
			'name'					=> 'Shop',
			'type'					=> 'module',
		),
		array(
			'id'					=> 17,
			'name'					=> 'Voting',
			'type'					=> 'module',
		),
		array(
			'id'					=> 18,
			'name'					=> 'Login',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 19,
			'name'					=> 'DocSys',
			'type'					=> 'module',
		),
		array(
			'id'					=> 20,
			'name'					=> 'Forum',
			'type'					=> 'module',
		),
		array(
			'id'					=> 21,
			'name'					=> 'Calendar',
			'type'					=> 'module',
		),
		array(
			'id'					=> 22,
			'name'					=> 'Feed',
			'type'					=> 'module',
		),
		array(
			'id'					=> 23,
			'name'					=> 'Access',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 24,
			'name'					=> 'Media2',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 25,
			'name'					=> 'Media3',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 27,
			'name'					=> 'Recommend',
			'type'					=> 'module',
		),
		array(
			'id'					=> 30,
			'name'					=> 'Livecam',
			'type'					=> 'module',
		),
		array(
			'id'					=> 31,
			'name'					=> 'MemberDir',
			'type'					=> 'module',
		),
		array(
			'id'					=> 32,
			'name'					=> 'NetTools',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 33,
			'name'					=> 'Market',
			'type'					=> 'module',
		),
		array(
			'id'					=> 35,
			'name'					=> 'Podcast',
			'type'					=> 'module',
		),
		array(
			'id'					=> 38,
			'name'					=> 'Egov',
			'type'					=> 'module',
		),
		array(
			'id'					=> 39,
			'name'					=> 'Media4',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 41,
			'name'					=> 'Alias',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 44,
			'name'					=> 'Imprint',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 45,
			'name'					=> 'Agb',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 46,
			'name'					=> 'Privacy',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 48,
			'name'					=> 'Data',
			'type'					=> 'module',
		),
		array(
			'id'					=> 49,
			'name'					=> 'Ecard',
			'type'					=> 'module',
		),
		array(
			'id'					=> 53,
			'name'					=> 'Downloads',
			'type'					=> 'module',
		),
		array(
			'id'					=> 54,
			'name'					=> 'U2u',
			'type'					=> 'module',
		),
		array(
			'id'					=> 56,
			'name'					=> 'Knowledge',
			'type'					=> 'module',
		),
		array(
			'id'					=> 57,
			'name'					=> 'Jobs',
			'type'					=> 'module',
		),
		array(
			'id'					=> 60,
			'name'					=> 'MediaDir',
			'type'					=> 'module',
		),
		array(
			'id'					=> 61,
			'name'					=> 'Captcha',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 63,
			'name'					=> 'JsonData',
			'type'					=> 'core',
		),
		array(
			'id'					=> 66,
			'name'					=> 'License',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 68,
			'name'					=> 'FileSharing',
			'type'					=> 'module',
		),
		array(
			'id'					=> 69,
			'name'					=> 'Crm',
			'type'					=> 'module',
		),
		array(
			'id'					=> 71,
			'name'					=> 'FrontendEditing',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 72,
			'name'					=> 'ContentManager',
			'type'					=> 'core',
		),
		/* dropped in 5.1.0
		array(
			'id'					=> 73,
			'name'					=> 'DatabaseManager',
			'type'					=> 'core',
		), */
		array(
			'id'					=> 74,
			'name'					=> 'SystemInfo',
			'type'					=> 'core',
		),
		array(
			'id'					=> 75,
			'name'					=> 'ViewManager',
			'type'					=> 'core',
		),
		array(
			'id'					=> 76,
			'name'					=> 'ComponentManager',
			'type'					=> 'core',
		),
		array(
			'id'					=> 77,
			'name'					=> 'LanguageManager',
			'type'					=> 'core',
		),
		array(
			'id'					=> 78,
			'name'					=> 'ContentWorkflow',
			'type'					=> 'core',
		),
		array(
			'id'					=> 79,
			'name'					=> 'SystemLog',
			'type'					=> 'core',
		),
		array(
			'id'					=> 80,
			'name'					=> 'Config',
			'type'					=> 'core',
		),
		array(
			'id'					=> 81,
			'name'					=> 'Cache',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 83,
			'name'					=> 'Media',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 84,
			'name'					=> 'Security',
			'type'					=> 'core',
		),
		array(
			'id'					=> 85,
			'name'					=> 'Csrf',
			'type'					=> 'core',
		),
		array(
			'id'					=> 86,
			'name'					=> 'Session',
			'type'					=> 'core',
		),
		array(
			'id'					=> 87,
			'name'					=> 'Message',
			'type'					=> 'core',
		),
		array(
			'id'					=> 88,
			'name'					=> 'JavaScript',
			'type'					=> 'core',
		),
		array(
			'id'					=> 90,
			'name'					=> 'Net',
			'type'					=> 'core',
		),
		array(
			'id'					=> 91,
			'name'					=> 'Core',
			'type'					=> 'core',
		),
		array(
			'id'					=> 92,
			'name'					=> 'Shell',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 99,
			'name'					=> 'Routing',
			'type'					=> 'core',
		),
		array(
			'id'					=> 101,
			'name'					=> 'Uploader',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 102,
			'name'					=> 'MediaBrowser',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 103,
			'name'					=> 'Cron',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 104,
			'name'					=> 'SysLog',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 105,
			'name'					=> 'NetManager',
			'type'					=> 'core',
		),
		array(
			'id'					=> 106,
			'name'					=> 'Wysiwyg',
			'type'					=> 'core',
		),
		array(
			'id'					=> 107,
			'name'					=> 'User',
			'type'					=> 'core',
		),
		array(
			'id'					=> 108,
			'name'					=> 'Html',
			'type'					=> 'core',
		),
		array(
			'id'					=> 109,
			'name'					=> 'MediaSource',
			'type'					=> 'core',
		),
		array(
			'id'					=> 110,
			'name'					=> 'TemplateEditor',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 111,
			'name'					=> 'GeoIp',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 112,
			'name'					=> 'DateTime',
			'type'					=> 'core',
		),
		array(
			'id'					=> 113,
			'name'					=> 'DataAccess',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 114,
			'name'					=> 'DataSource',
			'type'					=> 'core',
		),
		array(
			'id'					=> 116,
			'name'					=> 'Model',
			'type'					=> 'core',
		),
		array(
			'id'					=> 117,
			'name'					=> 'Pdf',
			'type'					=> 'core_module',
		),
		array(
			'id'					=> 118,
			'name'					=> 'Setting',
			'type'					=> 'core',
		),
		array(
			'id'					=> 119,
			'name'					=> 'Country',
			'type'					=> 'core',
		),
		array(
			'id'					=> 120,
			'name'					=> 'View',
			'type'					=> 'core',
		),
		array(
			'id'					=> 121,
			'name'					=> 'Locale',
			'type'					=> 'core',
		),
		array(
			'id'					=> 122,
			'name'					=> 'Widget',
			'type'					=> 'core_module',
		)
	);

    return $arrComponents;
}
